(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var log2 = Math.log2;
  var protoOf = kotlin_kotlin.$_$.d6;
  var interfaceMeta = kotlin_kotlin.$_$.r5;
  var setMetadataFor = kotlin_kotlin.$_$.e6;
  var toString = kotlin_kotlin.$_$.g6;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.x;
  var classMeta = kotlin_kotlin.$_$.i5;
  var getStringHashCode = kotlin_kotlin.$_$.p5;
  var THROW_CCE = kotlin_kotlin.$_$.d9;
  var objectMeta = kotlin_kotlin.$_$.c6;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.h;
  var charSequenceLength = kotlin_kotlin.$_$.g5;
  var charSequenceGet = kotlin_kotlin.$_$.f5;
  var toString_0 = kotlin_kotlin.$_$.l1;
  var Unit_instance = kotlin_kotlin.$_$.v1;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.h1;
  var arrayConcat = kotlin_kotlin.$_$.a;
  var listOf = kotlin_kotlin.$_$.r3;
  var withSign = kotlin_kotlin.$_$.i6;
  var VOID = kotlin_kotlin.$_$.c;
  var coerceAtLeast = kotlin_kotlin.$_$.k6;
  var getNumberHashCode = kotlin_kotlin.$_$.n5;
  var equals = kotlin_kotlin.$_$.k5;
  var numberToDouble = kotlin_kotlin.$_$.y5;
  var hashCode = kotlin_kotlin.$_$.q5;
  var roundToInt = kotlin_kotlin.$_$.h6;
  var DoubleCompanionObject_instance = kotlin_kotlin.$_$.q1;
  var coerceIn = kotlin_kotlin.$_$.o6;
  var Char = kotlin_kotlin.$_$.s8;
  var toInt = kotlin_kotlin.$_$.m8;
  var numberRangeToNumber = kotlin_kotlin.$_$.w5;
  var slice = kotlin_kotlin.$_$.c8;
  var startsWith = kotlin_kotlin.$_$.f8;
  var isInterface = kotlin_kotlin.$_$.u5;
  var contentEquals = kotlin_kotlin.$_$.l2;
  var coerceAtLeast_0 = kotlin_kotlin.$_$.m6;
  var objectCreate = kotlin_kotlin.$_$.b6;
  //endregion
  //region block: pre-declaration
  function toXYZ() {
    return this.jv().kv();
  }
  setMetadataFor(Color, 'Color', interfaceMeta);
  setMetadataFor(ColorComponentInfo, 'ColorComponentInfo', classMeta);
  setMetadataFor(WhitePoint, 'WhitePoint', classMeta);
  setMetadataFor(Illuminant, 'Illuminant', objectMeta);
  setMetadataFor(Companion, 'Companion', objectMeta);
  setMetadataFor(Ansi16, 'Ansi16', classMeta, VOID, [Color]);
  setMetadataFor(Companion_0, 'Companion', objectMeta);
  setMetadataFor(Ansi256, 'Ansi256', classMeta, VOID, [Color]);
  setMetadataFor(Companion_1, 'Companion', objectMeta);
  setMetadataFor(HSV, 'HSV', classMeta, VOID, [Color]);
  setMetadataFor(ICtCp, 'ICtCp', classMeta, VOID, [Color]);
  setMetadataFor(PqNonlinearity, 'PqNonlinearity', objectMeta);
  setMetadataFor(GammaTransferFunctions, 'GammaTransferFunctions', classMeta);
  setMetadataFor(LinearTransferFunctions, 'LinearTransferFunctions', objectMeta);
  function invoke$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.tw(r, g, b, alpha) : $super.tw.call(this, r, g, b, alpha);
  }
  function invoke(r, g, b, alpha) {
    return this.tw(numberToDouble(r), numberToDouble(g), numberToDouble(b), numberToDouble(alpha));
  }
  function invoke$default_0(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.yx(r, g, b, alpha) : invoke(r, g, b, alpha);
  }
  function from255(r, g, b, alpha) {
    return this.tw(r / 255.0, g / 255.0, b / 255.0, alpha / 255.0);
  }
  function from255$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 255 : alpha;
    return $super === VOID ? this.zx(r, g, b, alpha) : from255(r, g, b, alpha);
  }
  function invoke_0(hex) {
    var tmp = parseHex(validateHex(hex), 0);
    var tmp_0 = parseHex(hex, 1);
    var tmp_1 = parseHex(hex, 2);
    var tmp_2;
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.RGBColorSpace.invoke.<anonymous>' call
    var it = get_hexLength(hex);
    if (it === 4 ? true : it === 8) {
      tmp_2 = parseHex(hex, 3);
    } else {
      tmp_2 = 255;
    }
    return this.zx(tmp, tmp_0, tmp_1, tmp_2);
  }
  setMetadataFor(RGBColorSpace, 'RGBColorSpace', interfaceMeta);
  setMetadataFor(Companion_2, 'Companion', objectMeta, VOID, [RGBColorSpace]);
  setMetadataFor(RGB, 'RGB', classMeta, VOID, [Color]);
  setMetadataFor(RGBColorSpaces, 'RGBColorSpaces', objectMeta);
  setMetadataFor(SRGB, 'SRGB', objectMeta, VOID, [RGBColorSpace]);
  setMetadataFor(RGBColorSpaceImpl, 'RGBColorSpaceImpl', classMeta, VOID, [RGBColorSpace]);
  setMetadataFor(SRGBTransferFunctions, 'SRGBTransferFunctions', objectMeta);
  setMetadataFor(ACESccTransferFunctions, 'ACESccTransferFunctions', objectMeta);
  setMetadataFor(ACEScctTransferFunctions, 'ACEScctTransferFunctions', objectMeta);
  setMetadataFor(BT2020TransferFunctions, 'BT2020TransferFunctions', objectMeta);
  setMetadataFor(BT709TransferFunctions, 'BT709TransferFunctions', objectMeta);
  setMetadataFor(ROMMTransferFunctions, 'ROMMTransferFunctions', objectMeta);
  setMetadataFor(XYZColorSpace, 'XYZColorSpace', interfaceMeta);
  setMetadataFor(Companion_3, 'Companion', objectMeta, VOID, [XYZColorSpace]);
  setMetadataFor(XYZ, 'XYZ', classMeta, VOID, [Color]);
  setMetadataFor(XYZColorSpaces, 'XYZColorSpaces', objectMeta);
  setMetadataFor(XYZColorSpaceImpl, 'XYZColorSpaceImpl', classMeta, VOID, [XYZColorSpace]);
  setMetadataFor(xyY, 'xyY', classMeta);
  //endregion
  function Color() {
  }
  function ColorComponentInfo(name, isPolar, min, max) {
    this.qv_1 = name;
    this.rv_1 = isPolar;
    this.sv_1 = min;
    this.tv_1 = max;
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.sv_1 <= this.tv_1)) {
      // Inline function 'com.github.ajalt.colormath.ColorComponentInfo.<anonymous>' call
      var message = 'min must be less than or equal to max';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
  }
  function WhitePoint(name, chromaticity) {
    this.uv_1 = name;
    this.vv_1 = chromaticity;
  }
  protoOf(WhitePoint).toString = function () {
    return this.uv_1;
  };
  protoOf(WhitePoint).hashCode = function () {
    var result = getStringHashCode(this.uv_1);
    result = imul(result, 31) + this.vv_1.hashCode() | 0;
    return result;
  };
  protoOf(WhitePoint).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof WhitePoint))
      return false;
    var tmp0_other_with_cast = other instanceof WhitePoint ? other : THROW_CCE();
    if (!(this.uv_1 === tmp0_other_with_cast.uv_1))
      return false;
    if (!this.vv_1.equals(tmp0_other_with_cast.vv_1))
      return false;
    return true;
  };
  function Illuminant() {
    Illuminant_instance = this;
    this.wv_1 = new WhitePoint('A', xyY_init_$Create$(0.44758, 0.40745));
    this.xv_1 = new WhitePoint('B', xyY_init_$Create$(0.34842, 0.35161));
    this.yv_1 = new WhitePoint('C', xyY_init_$Create$(0.31006, 0.31616));
    this.zv_1 = new WhitePoint('D50', xyY_init_$Create$(0.3457, 0.3585));
    this.aw_1 = new WhitePoint('D55', xyY_init_$Create$(0.33243, 0.34744));
    this.bw_1 = new WhitePoint('D65', xyY_init_$Create$(0.3127, 0.329));
    this.cw_1 = new WhitePoint('D75', xyY_init_$Create$(0.29903, 0.31488));
    this.dw_1 = new WhitePoint('E', xyY_init_$Create$(0.3333333333333333, 0.3333333333333333));
  }
  var Illuminant_instance;
  function Illuminant_getInstance() {
    if (Illuminant_instance == null)
      new Illuminant();
    return Illuminant_instance;
  }
  function get_alphaInfo() {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return alphaInfo;
  }
  var alphaInfo;
  function zeroOneComponentInfo(name) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), false, 0.0, 1.0);
      this_0.o(tmp$ret$0);
    }
    this_0.o(get_alphaInfo());
    return this_0.c3();
  }
  function polarComponentInfo(name, l, r) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), item === _Char___init__impl__6a9atx(72), item === _Char___init__impl__6a9atx(72) ? 0.0 : l, item === _Char___init__impl__6a9atx(72) ? 360.0 : r);
      this_0.o(tmp$ret$0);
    }
    this_0.o(get_alphaInfo());
    return this_0.c3();
  }
  function componentInfoList(c) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return listOf(arrayConcat([c, [get_alphaInfo()]]));
  }
  var properties_initialized_ColorSpaceUtils_kt_kskdoe;
  function _init_properties_ColorSpaceUtils_kt__cnwylg() {
    if (!properties_initialized_ColorSpaceUtils_kt_kskdoe) {
      properties_initialized_ColorSpaceUtils_kt_kskdoe = true;
      alphaInfo = new ColorComponentInfo('alpha', false, 0.0, 1.0);
    }
  }
  function get_CAT02_XYZ_TO_LMS() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_XYZ_TO_LMS;
  }
  var CAT02_XYZ_TO_LMS;
  function get_CAT02_LMS_TO_XYZ() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_LMS_TO_XYZ;
  }
  var CAT02_LMS_TO_XYZ;
  var properties_initialized_Constants_kt_w4w61t;
  function _init_properties_Constants_kt__atb1ur() {
    if (!properties_initialized_Constants_kt_w4w61t) {
      properties_initialized_Constants_kt_w4w61t = true;
      CAT02_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.7328, 0.4296, -0.1624, -0.7036, 1.6975, 0.0061, 0.003, 0.0136, 0.9834);
      CAT02_LMS_TO_XYZ = inverse(get_CAT02_XYZ_TO_LMS());
    }
  }
  function spow(_this__u8e3s4, p) {
    return spow_0(_this__u8e3s4, p);
  }
  function normalizeDeg(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function spow_0(_this__u8e3s4, p) {
    // Inline function 'kotlin.math.pow' call
    // Inline function 'kotlin.math.absoluteValue' call
    var this_0 = Math.abs(_this__u8e3s4);
    var tmp$ret$1 = Math.pow(this_0, p);
    return withSign(tmp$ret$1, _this__u8e3s4);
  }
  function normalizeDeg_0(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function _Matrix___init__impl__q3kp4w(rowMajor) {
    return rowMajor;
  }
  function _Matrix___get_rowMajor__impl__vmgxkq($this) {
    return $this;
  }
  function _Matrix___init__impl__q3kp4w_0(v00, v10, v20, v01, v11, v21, v02, v12, v22) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v00, v10, v20, v01, v11, v21, v02, v12, v22]);
    return _Matrix___init__impl__q3kp4w(tmp$ret$0);
  }
  function Matrix__copy_impl_kmkvzd($this) {
    // Inline function 'kotlin.collections.copyOf' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp$ret$1 = _Matrix___get_rowMajor__impl__vmgxkq($this).slice();
    return _Matrix___init__impl__q3kp4w(tmp$ret$1);
  }
  function Matrix__get_impl_xogbpk($this, x, y) {
    return _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0];
  }
  function Matrix__set_impl_s2l54c($this, x, y, value) {
    _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0] = value;
  }
  function Matrix__set_impl_s2l54c_0($this, x, y, value) {
    return Matrix__set_impl_s2l54c($this, x, y, value);
  }
  function inverse(_this__u8e3s4, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var a = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0);
    var b = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0);
    var c = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0);
    var d = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1);
    var e = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1);
    var f = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1);
    var g = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2);
    var h = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2);
    var i = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2);
    var A = e * i - h * f;
    var B = h * c - b * i;
    var C = b * f - e * c;
    var det = a * A + d * B + g * C;
    var out = inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4);
    Matrix__set_impl_s2l54c_0(out, 0, 0, A / det);
    Matrix__set_impl_s2l54c_0(out, 0, 1, (g * f - d * i) / det);
    Matrix__set_impl_s2l54c_0(out, 0, 2, (d * h - g * e) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 0, B / det);
    Matrix__set_impl_s2l54c_0(out, 1, 1, (a * i - g * c) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 2, (g * b - a * h) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 0, C / det);
    Matrix__set_impl_s2l54c_0(out, 2, 1, (d * c - a * f) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 2, (a * e - d * b) / det);
    return out;
  }
  function scalarDiv(_this__u8e3s4, x, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var out = _Matrix___get_rowMajor__impl__vmgxkq(inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4));
    var inductionVariable = 0;
    var last = out.length - 1 | 0;
    if (inductionVariable <= last)
      do {
        var i = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        out[i] = out[i] / x;
      }
       while (inductionVariable <= last);
    return _Matrix___init__impl__q3kp4w(out);
  }
  function dot(_this__u8e3s4, other) {
    return _Matrix___init__impl__q3kp4w_0(dot$f(_this__u8e3s4, other, 0, 0), dot$f(_this__u8e3s4, other, 1, 0), dot$f(_this__u8e3s4, other, 2, 0), dot$f(_this__u8e3s4, other, 0, 1), dot$f(_this__u8e3s4, other, 1, 1), dot$f(_this__u8e3s4, other, 2, 1), dot$f(_this__u8e3s4, other, 0, 2), dot$f(_this__u8e3s4, other, 1, 2), dot$f(_this__u8e3s4, other, 2, 2));
  }
  function dotDiagonal(_this__u8e3s4, v0, v1, v2) {
    return _Matrix___init__impl__q3kp4w_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function _Vector___init__impl__y7x4qq(values) {
    return values;
  }
  function _Vector___get_values__impl__3gdbp5($this) {
    return $this;
  }
  function _Vector___init__impl__y7x4qq_0(v0, v1, v2) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v0, v1, v2]);
    return _Vector___init__impl__y7x4qq(tmp$ret$0);
  }
  function _Vector___get_l__impl__envr1l($this) {
    return _Vector___get_values__impl__3gdbp5($this)[0];
  }
  function _Vector___get_m__impl__e5qq0m($this) {
    return _Vector___get_values__impl__3gdbp5($this)[1];
  }
  function _Vector___get_s__impl__pzuljk($this) {
    return _Vector___get_values__impl__3gdbp5($this)[2];
  }
  function dot_0(_this__u8e3s4, v0, v1, v2) {
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    return _Vector___init__impl__y7x4qq_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function dot$f($this_dot, $other, x, y) {
    return Matrix__get_impl_xogbpk($this_dot, 0, y) * Matrix__get_impl_xogbpk($other, x, 0) + Matrix__get_impl_xogbpk($this_dot, 1, y) * Matrix__get_impl_xogbpk($other, x, 1) + Matrix__get_impl_xogbpk($this_dot, 2, y) * Matrix__get_impl_xogbpk($other, x, 2);
  }
  function Companion() {
    Companion_instance = this;
    this.ew_1 = componentInfoList([new ColorComponentInfo('code', false, 30.0, 107.0)]);
  }
  protoOf(Companion).fw = function () {
    return this.ew_1;
  };
  var Companion_instance;
  function Companion_getInstance() {
    if (Companion_instance == null)
      new Companion();
    return Companion_instance;
  }
  function Ansi16(code) {
    Companion_getInstance();
    this.gw_1 = code;
  }
  protoOf(Ansi16).iv = function () {
    return Companion_getInstance();
  };
  protoOf(Ansi16).jv = function () {
    switch (this.gw_1) {
      case 30:
      case 40:
        return Companion_getInstance_2().hw(0.0, 0.0, 0.0);
      case 90:
      case 100:
        return Companion_getInstance_2().iw(128, 128, 128);
      case 37:
      case 47:
        return Companion_getInstance_2().iw(192, 192, 192);
      case 97:
      case 107:
        return Companion_getInstance_2().hw(1.0, 1.0, 1.0);
    }
    var color = this.gw_1 % 10 | 0;
    var mul = this.gw_1 > 50 ? 1.0 : 0.5;
    var r = (color % 2 | 0) * mul;
    var g = ((color / 2 | 0) % 2 | 0) * mul;
    var b = ((color / 4 | 0) % 2 | 0) * mul;
    return Companion_getInstance_2().hw(r, g, b);
  };
  protoOf(Ansi16).toString = function () {
    return 'Ansi16(code=' + this.gw_1 + ')';
  };
  protoOf(Ansi16).hashCode = function () {
    return this.gw_1;
  };
  protoOf(Ansi16).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi16))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi16 ? other : THROW_CCE();
    if (!(this.gw_1 === tmp0_other_with_cast.gw_1))
      return false;
    return true;
  };
  function Companion_0() {
    Companion_instance_0 = this;
    this.jw_1 = componentInfoList([new ColorComponentInfo('code', false, 0.0, 255.0)]);
  }
  protoOf(Companion_0).fw = function () {
    return this.jw_1;
  };
  var Companion_instance_0;
  function Companion_getInstance_0() {
    if (Companion_instance_0 == null)
      new Companion_0();
    return Companion_instance_0;
  }
  function Ansi256(code) {
    Companion_getInstance_0();
    this.kw_1 = code;
  }
  protoOf(Ansi256).iv = function () {
    return Companion_getInstance_0();
  };
  protoOf(Ansi256).jv = function () {
    if (this.kw_1 < 16)
      return this.lw().jv();
    if (this.kw_1 >= 232) {
      var c = imul(this.kw_1 - 232 | 0, 10) + 8 | 0;
      return Companion_getInstance_2().iw(c, c, c);
    }
    var c_0 = this.kw_1 - 16 | 0;
    var rem = c_0 % 36 | 0;
    // Inline function 'kotlin.math.floor' call
    var x = c_0 / 36.0;
    var r = Math.floor(x) / 5.0;
    // Inline function 'kotlin.math.floor' call
    var x_0 = rem / 6.0;
    var g = Math.floor(x_0) / 5.0;
    var b = (rem % 6 | 0) / 5.0;
    return Companion_getInstance_2().mw(r, g, b);
  };
  protoOf(Ansi256).lw = function () {
    return this.kw_1 < 8 ? new Ansi16(this.kw_1 + 30 | 0) : this.kw_1 < 16 ? new Ansi16((this.kw_1 - 8 | 0) + 90 | 0) : this.jv().lw();
  };
  protoOf(Ansi256).toString = function () {
    return 'Ansi256(code=' + this.kw_1 + ')';
  };
  protoOf(Ansi256).hashCode = function () {
    return this.kw_1;
  };
  protoOf(Ansi256).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi256))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi256 ? other : THROW_CCE();
    if (!(this.kw_1 === tmp0_other_with_cast.kw_1))
      return false;
    return true;
  };
  function Companion_1() {
    Companion_instance_1 = this;
    this.nw_1 = polarComponentInfo('HSV', 0.0, 1.0);
  }
  protoOf(Companion_1).fw = function () {
    return this.nw_1;
  };
  var Companion_instance_1;
  function Companion_getInstance_1() {
    if (Companion_instance_1 == null)
      new Companion_1();
    return Companion_instance_1;
  }
  function toSRGB$f(h, v, s, n) {
    var k = (n + h) % 6;
    var tmp = v * s;
    // Inline function 'kotlin.comparisons.minOf' call
    var b = 4 - k;
    var tmp$ret$0 = Math.min(k, b, 1.0);
    return v - tmp * coerceAtLeast(tmp$ret$0, 0.0);
  }
  function HSV(h, s, v, alpha) {
    Companion_getInstance_1();
    alpha = alpha === VOID ? 1.0 : alpha;
    this.ow_1 = h;
    this.pw_1 = s;
    this.qw_1 = v;
    this.rw_1 = alpha;
  }
  protoOf(HSV).iv = function () {
    return Companion_getInstance_1();
  };
  protoOf(HSV).jv = function () {
    if (this.pw_1 < 1.0E-7)
      return Companion_getInstance_2().tw(this.qw_1, this.qw_1, this.qw_1, this.rw_1);
    var v = this.qw_1;
    var h = normalizeDeg_0(this.ow_1) / 60.0;
    var s = this.pw_1;
    return SRGB_getInstance().tw(toSRGB$f(h, v, s, 5), toSRGB$f(h, v, s, 3), toSRGB$f(h, v, s, 1), this.rw_1);
  };
  protoOf(HSV).toString = function () {
    return 'HSV(h=' + this.ow_1 + ', s=' + this.pw_1 + ', v=' + this.qw_1 + ', alpha=' + this.rw_1 + ')';
  };
  protoOf(HSV).hashCode = function () {
    var result = getNumberHashCode(this.ow_1);
    result = imul(result, 31) + getNumberHashCode(this.pw_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.qw_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.rw_1) | 0;
    return result;
  };
  protoOf(HSV).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof HSV))
      return false;
    var tmp0_other_with_cast = other instanceof HSV ? other : THROW_CCE();
    if (!equals(this.ow_1, tmp0_other_with_cast.ow_1))
      return false;
    if (!equals(this.pw_1, tmp0_other_with_cast.pw_1))
      return false;
    if (!equals(this.qw_1, tmp0_other_with_cast.qw_1))
      return false;
    if (!equals(this.rw_1, tmp0_other_with_cast.rw_1))
      return false;
    return true;
  };
  function get_ICTCP_RGB_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_RGB_TO_LMS;
  }
  var ICTCP_RGB_TO_LMS;
  function get_ICTCP_LMS_TO_ICTCP() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_TO_ICTCP;
  }
  var ICTCP_LMS_TO_ICTCP;
  function get_ICTCP_LMS_to_RGB() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_to_RGB;
  }
  var ICTCP_LMS_to_RGB;
  function get_ICTCP_ICTCP_to_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_ICTCP_to_LMS;
  }
  var ICTCP_ICTCP_to_LMS;
  function get_ICTCP_CROSSTALK() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_CROSSTALK;
  }
  var ICTCP_CROSSTALK;
  function get_HPE_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return HPE_XYZ_TO_LMS;
  }
  var HPE_XYZ_TO_LMS;
  function get_ICTCP_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_XYZ_TO_LMS;
  }
  var ICTCP_XYZ_TO_LMS;
  var ICTCP_LMS_TO_XYZ;
  function ICtCp() {
  }
  protoOf(ICtCp).zw = function () {
    var fo = RGBColorSpaces_getInstance().hx_1.mx();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = get_ICTCP_ICTCP_to_LMS();
    var v0 = this.vw_1;
    var v1 = this.ww_1;
    var v2 = this.xw_1;
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>' call
    var l = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var m = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var s = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_1 = get_ICTCP_LMS_to_RGB();
    var v0_0 = PqNonlinearity_instance.vx(l);
    var v1_0 = PqNonlinearity_instance.vx(m);
    var v2_0 = PqNonlinearity_instance.vx(s);
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_1, 0, 0) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 0) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 0) * v2_0;
    var g = Matrix__get_impl_xogbpk(this_1, 0, 1) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 1) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 1) * v2_0;
    var b = Matrix__get_impl_xogbpk(this_1, 0, 2) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 2) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 2) * v2_0;
    return RGBColorSpaces_getInstance().hx_1.tw(fo.wx(r), fo.wx(g), fo.wx(b), this.yw_1);
  };
  function PqNonlinearity() {
    this.nx_1 = 0.1593017578125;
    this.ox_1 = 78.84375;
    this.px_1 = 0.8359375;
    this.qx_1 = 18.8515625;
    this.rx_1 = 18.6875;
    this.sx_1 = 10000.0;
    this.tx_1 = 6.277394636015326;
    this.ux_1 = 0.012683313515655966;
  }
  protoOf(PqNonlinearity).vx = function (x) {
    var vp = spow(x, 0.012683313515655966);
    var n = coerceAtLeast(vp - 0.8359375, 0.0);
    var l = spow_0(n / (18.8515625 - 18.6875 * vp), 6.277394636015326);
    return 10000.0 * l;
  };
  protoOf(PqNonlinearity).wx = function (x) {
    var yp = spow_0(x / 10000.0, 0.1593017578125);
    return spow_0((0.8359375 + 18.8515625 * yp) / (1.0 + 18.6875 * yp), 78.84375);
  };
  var PqNonlinearity_instance;
  function PqNonlinearity_getInstance() {
    return PqNonlinearity_instance;
  }
  var properties_initialized_ICtCp_kt_w6y8uv;
  function _init_properties_ICtCp_kt__7vx7or() {
    if (!properties_initialized_ICtCp_kt_w6y8uv) {
      properties_initialized_ICtCp_kt_w6y8uv = true;
      ICTCP_RGB_TO_LMS = scalarDiv(_Matrix___init__impl__q3kp4w_0(1688.0, 2146.0, 262.0, 683.0, 2951.0, 462.0, 99.0, 309.0, 3688.0), 4096.0, true);
      ICTCP_LMS_TO_ICTCP = scalarDiv(_Matrix___init__impl__q3kp4w_0(2048.0, 2048.0, 0.0, 6610.0, -13613.0, 7003.0, 17933.0, -17390.0, -543.0), 4096.0, true);
      ICTCP_LMS_to_RGB = inverse(get_ICTCP_RGB_TO_LMS());
      ICTCP_ICTCP_to_LMS = inverse(get_ICTCP_LMS_TO_ICTCP());
      ICTCP_CROSSTALK = _Matrix___init__impl__q3kp4w_0(0.92, 0.04, 0.04, 0.04, 0.92, 0.04, 0.04, 0.04, 0.92);
      HPE_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.4002, 0.7076, -0.0808, -0.2263, 1.1653, 0.0457, 0.0, 0.0, 0.9182);
      ICTCP_XYZ_TO_LMS = dot(get_ICTCP_CROSSTALK(), get_HPE_XYZ_TO_LMS());
      ICTCP_LMS_TO_XYZ = inverse(get_ICTCP_XYZ_TO_LMS());
    }
  }
  function GammaTransferFunctions(gamma) {
    this.xx_1 = gamma;
  }
  protoOf(GammaTransferFunctions).vx = function (x) {
    return spow(x, this.xx_1);
  };
  protoOf(GammaTransferFunctions).wx = function (x) {
    return spow(x, 1.0 / this.xx_1);
  };
  protoOf(GammaTransferFunctions).toString = function () {
    return 'GammaTransferFunctions(gamma=' + this.xx_1 + ')';
  };
  protoOf(GammaTransferFunctions).hashCode = function () {
    return getNumberHashCode(this.xx_1);
  };
  protoOf(GammaTransferFunctions).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GammaTransferFunctions))
      return false;
    var tmp0_other_with_cast = other instanceof GammaTransferFunctions ? other : THROW_CCE();
    if (!equals(this.xx_1, tmp0_other_with_cast.xx_1))
      return false;
    return true;
  };
  function LinearTransferFunctions() {
  }
  protoOf(LinearTransferFunctions).vx = function (x) {
    return x;
  };
  protoOf(LinearTransferFunctions).wx = function (x) {
    return x;
  };
  var LinearTransferFunctions_instance;
  function LinearTransferFunctions_getInstance() {
    return LinearTransferFunctions_instance;
  }
  function RGBColorSpace() {
  }
  function Companion_2() {
    Companion_instance_2 = this;
    this.sw_1 = RGBColorSpaces_getInstance().ax_1;
  }
  protoOf(Companion_2).fw = function () {
    return this.sw_1.fw();
  };
  protoOf(Companion_2).cy = function () {
    return this.sw_1.cy();
  };
  protoOf(Companion_2).by = function () {
    return this.sw_1.by();
  };
  protoOf(Companion_2).po = function () {
    return this.sw_1.po();
  };
  protoOf(Companion_2).mx = function () {
    return this.sw_1.mx();
  };
  protoOf(Companion_2).dy = function () {
    return this.sw_1.dy();
  };
  protoOf(Companion_2).zx = function (r, g, b, alpha) {
    return this.sw_1.zx(r, g, b, alpha);
  };
  protoOf(Companion_2).tw = function (r, g, b, alpha) {
    return this.sw_1.tw(r, g, b, alpha);
  };
  protoOf(Companion_2).yx = function (r, g, b, alpha) {
    return this.sw_1.yx(r, g, b, alpha);
  };
  protoOf(Companion_2).ay = function (hex) {
    return this.sw_1.ay(hex);
  };
  protoOf(Companion_2).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().ax_1, other);
  };
  protoOf(Companion_2).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().ax_1);
  };
  var Companion_instance_2;
  function Companion_getInstance_2() {
    if (Companion_instance_2 == null)
      new Companion_2();
    return Companion_instance_2;
  }
  function clamp$copy(receiver, p0, p1, p2, p3) {
    return receiver.ey(p0, p1, p2, p3);
  }
  function RGB(r, g, b, alpha, space) {
    Companion_getInstance_2();
    this.lv_1 = r;
    this.mv_1 = g;
    this.nv_1 = b;
    this.ov_1 = alpha;
    this.pv_1 = space;
  }
  protoOf(RGB).iv = function () {
    return this.pv_1;
  };
  protoOf(RGB).fy = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.lv_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).gy = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.mv_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).hy = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.nv_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).iy = function (space) {
    var f = SRGB_getInstance().mx();
    return equals(this.pv_1, space) ? this : (equals(this.pv_1, SRGB_getInstance()) ? equals(space, RGBColorSpaces_getInstance().bx_1) : false) ? space.tw(f.vx(this.lv_1), f.vx(this.mv_1), f.vx(this.nv_1), this.ov_1) : (equals(this.pv_1, RGBColorSpaces_getInstance().bx_1) ? equals(space, SRGB_getInstance()) : false) ? space.tw(f.wx(this.lv_1), f.wx(this.mv_1), f.wx(this.nv_1), this.ov_1) : this.kv().oy(space);
  };
  protoOf(RGB).py = function () {
    var tmp$ret$3;
    $l$block: {
      // Inline function 'com.github.ajalt.colormath.model.RGB.srgbHueMinMaxChroma' call
      // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
      var $this$toSRGB = this.iy(SRGB_getInstance());
      var r = $this$toSRGB.lv_1;
      var g = $this$toSRGB.mv_1;
      var b = $this$toSRGB.nv_1;
      // Inline function 'kotlin.comparisons.minOf' call
      var min = Math.min(r, g, b);
      // Inline function 'kotlin.comparisons.maxOf' call
      var max = Math.max(r, g, b);
      var chroma = max - min;
      var tmp;
      if (chroma < 1.0E-7) {
        tmp = NaN;
      } else if (r === max) {
        tmp = (g - b) / chroma;
      } else if (g === max) {
        tmp = 2 + (b - r) / chroma;
      } else if (b === max) {
        tmp = 4 + (r - g) / chroma;
      } else {
        tmp = 0.0;
      }
      var h = tmp * 60;
      // Inline function 'com.github.ajalt.colormath.model.RGB.toHSV.<anonymous>' call
      var h_0 = normalizeDeg(h);
      var s = max === 0.0 ? 0.0 : chroma / max;
      tmp$ret$3 = new HSV(h_0, s, max, this.ov_1);
      break $l$block;
    }
    return tmp$ret$3;
  };
  protoOf(RGB).kv = function () {
    var f = this.pv_1.mx();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(this.pv_1.by());
    var v0 = f.vx(this.lv_1);
    var v1 = f.vx(this.mv_1);
    var v2 = f.vx(this.nv_1);
    // Inline function 'com.github.ajalt.colormath.model.RGB.toXYZ.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return XYZColorSpace_0(this.pv_1.dy()).tw(x, y, z, this.ov_1);
  };
  protoOf(RGB).lw = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.iy(SRGB_getInstance());
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = $this$toSRGB.py().qw_1 * 100;
    var value = roundToInt(this_0);
    if (value === 30)
      return new Ansi16(30);
    var v = value / 50 | 0;
    // Inline function 'kotlin.math.roundToInt' call
    var this_1 = $this$toSRGB.nv_1;
    var tmp$ret$1 = roundToInt(this_1);
    var tmp = imul(tmp$ret$1, 4);
    // Inline function 'kotlin.math.roundToInt' call
    var this_2 = $this$toSRGB.mv_1;
    var tmp$ret$2 = roundToInt(this_2);
    var tmp_0 = tmp | imul(tmp$ret$2, 2);
    // Inline function 'kotlin.math.roundToInt' call
    var this_3 = $this$toSRGB.lv_1;
    var ansi = 30 + (tmp_0 | roundToInt(this_3)) | 0;
    return new Ansi16(v === 2 ? ansi + 60 | 0 : ansi);
  };
  protoOf(RGB).qy = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.iy(SRGB_getInstance());
    var ri = $this$toSRGB.fy();
    var gi = $this$toSRGB.gy();
    var bi = $this$toSRGB.hy();
    var tmp;
    if (ri === gi ? gi === bi : false) {
      tmp = ri < 8 ? 16 : ri > 248 ? 231 : roundToInt((ri - 8 | 0) / 247.0 * 24.0) + 232 | 0;
    } else {
      // Inline function 'kotlin.math.roundToInt' call
      var this_0 = $this$toSRGB.lv_1 * 5;
      var tmp$ret$0 = roundToInt(this_0);
      var tmp_0 = 16 + imul(36, tmp$ret$0) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_1 = $this$toSRGB.mv_1 * 5;
      var tmp$ret$1 = roundToInt(this_1);
      var tmp_1 = tmp_0 + imul(6, tmp$ret$1) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_2 = $this$toSRGB.nv_1 * 5;
      tmp = tmp_1 + roundToInt(this_2) | 0;
    }
    var code = tmp;
    return new Ansi256(code);
  };
  protoOf(RGB).jv = function () {
    return this.iy(RGBColorSpaces_getInstance().ax_1);
  };
  protoOf(RGB).ry = function () {
    // Inline function 'com.github.ajalt.colormath.internal.clamp3' call
    var v1 = this.lv_1;
    var v2 = this.mv_1;
    var v3 = this.nv_1;
    var alpha = this.ov_1;
    var tmp0_container = this.iv().fw();
    // Inline function 'kotlin.collections.component1' call
    var c1 = tmp0_container.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var c2 = tmp0_container.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var c3 = tmp0_container.c1(2);
    var tmp;
    var tmp_0;
    var tmp_1;
    var tmp_2;
    var containsLower = c1.sv_1;
    if (v1 <= c1.tv_1 ? containsLower <= v1 : false) {
      var containsLower_0 = c2.sv_1;
      tmp_2 = v2 <= c2.tv_1 ? containsLower_0 <= v2 : false;
    } else {
      tmp_2 = false;
    }
    if (tmp_2) {
      var containsLower_1 = c3.sv_1;
      tmp_1 = v3 <= c3.tv_1 ? containsLower_1 <= v3 : false;
    } else {
      tmp_1 = false;
    }
    if (tmp_1) {
      tmp_0 = 0.0 <= alpha ? alpha <= 1.0 : false;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = this;
    } else {
      tmp = clamp$copy(this, coerceIn(v1, c1.sv_1, c1.tv_1), coerceIn(v2, c2.sv_1, c2.tv_1), coerceIn(v3, c3.sv_1, c3.tv_1), coerceIn(alpha, 0.0, 1.0));
    }
    return tmp;
  };
  protoOf(RGB).sy = function (r, g, b, alpha, space) {
    return new RGB(r, g, b, alpha, space);
  };
  protoOf(RGB).ey = function (r, g, b, alpha, space, $super) {
    r = r === VOID ? this.lv_1 : r;
    g = g === VOID ? this.mv_1 : g;
    b = b === VOID ? this.nv_1 : b;
    alpha = alpha === VOID ? this.ov_1 : alpha;
    space = space === VOID ? this.pv_1 : space;
    return $super === VOID ? this.sy(r, g, b, alpha, space) : $super.sy.call(this, r, g, b, alpha, space);
  };
  protoOf(RGB).toString = function () {
    return 'RGB(r=' + this.lv_1 + ', g=' + this.mv_1 + ', b=' + this.nv_1 + ', alpha=' + this.ov_1 + ', space=' + this.pv_1 + ')';
  };
  protoOf(RGB).hashCode = function () {
    var result = getNumberHashCode(this.lv_1);
    result = imul(result, 31) + getNumberHashCode(this.mv_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.nv_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.ov_1) | 0;
    result = imul(result, 31) + hashCode(this.pv_1) | 0;
    return result;
  };
  protoOf(RGB).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof RGB))
      return false;
    var tmp0_other_with_cast = other instanceof RGB ? other : THROW_CCE();
    if (!equals(this.lv_1, tmp0_other_with_cast.lv_1))
      return false;
    if (!equals(this.mv_1, tmp0_other_with_cast.mv_1))
      return false;
    if (!equals(this.nv_1, tmp0_other_with_cast.nv_1))
      return false;
    if (!equals(this.ov_1, tmp0_other_with_cast.ov_1))
      return false;
    if (!equals(this.pv_1, tmp0_other_with_cast.pv_1))
      return false;
    return true;
  };
  function parseHex(_this__u8e3s4, startIndex) {
    var tmp;
    if (get_hexLength(_this__u8e3s4) > 4) {
      var i = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? imul(startIndex, 2) + 1 | 0 : imul(startIndex, 2);
      tmp = toInt(slice(_this__u8e3s4, numberRangeToNumber(i, i + 1 | 0)), 16);
    } else {
      var i_0 = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? startIndex + 1 | 0 : startIndex;
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.colormath.model.parseHex.<anonymous>' call
      var it = charSequenceGet(_this__u8e3s4, i_0);
      var tmp$ret$1 = toString_0(it) + toString_0(it);
      tmp = toInt(tmp$ret$1, 16);
    }
    return tmp;
  }
  function validateHex(_this__u8e3s4) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>' call
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
    var it = get_hexLength(_this__u8e3s4);
    switch (it) {
      case 3:
      case 4:
      case 6:
        var tmp$ret$0 = true;
        break;
      default:
        tmp$ret$0 = it === 8;
        break;
    }
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp$ret$0) {
      // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
      var message = 'Hex string must be in the format "#ffffff" or "ffffff"';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
    return _this__u8e3s4;
  }
  function get_hexLength(_this__u8e3s4) {
    return startsWith(_this__u8e3s4, '#') ? _this__u8e3s4.length - 1 | 0 : _this__u8e3s4.length;
  }
  function get_SRGB_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_R;
  }
  var SRGB_R;
  function get_SRGB_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_G;
  }
  var SRGB_G;
  function get_SRGB_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_B;
  }
  var SRGB_B;
  function get_ACES_WHITE_POINT() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_WHITE_POINT;
  }
  var ACES_WHITE_POINT;
  function get_ACES_AP0_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_R;
  }
  var ACES_AP0_R;
  function get_ACES_AP0_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_G;
  }
  var ACES_AP0_G;
  function get_ACES_AP0_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_B;
  }
  var ACES_AP0_B;
  function get_ACES_AP1_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_R;
  }
  var ACES_AP1_R;
  function get_ACES_AP1_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_G;
  }
  var ACES_AP1_G;
  function get_ACES_AP1_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_B;
  }
  var ACES_AP1_B;
  function RGBColorSpaces$SRGB$lambda($this$$receiver, it) {
    return it.jv();
  }
  function RGBColorSpaces$BT2020$lambda($this$$receiver, color) {
    var tmp;
    if (color instanceof RGB) {
      tmp = color.iy($this$$receiver);
    } else {
      if (color instanceof ICtCp) {
        tmp = color.zw();
      } else {
        tmp = color.kv().oy($this$$receiver);
      }
    }
    return tmp;
  }
  function RGBColorSpaces() {
    RGBColorSpaces_instance = this;
    var tmp = this;
    var tmp_0 = Illuminant_getInstance().bw_1;
    var tmp_1 = SRGBTransferFunctions_instance;
    var tmp_2 = get_SRGB_R();
    var tmp_3 = get_SRGB_G();
    var tmp_4 = get_SRGB_B();
    tmp.ax_1 = new RGBColorSpaceImpl('sRGB', tmp_0, tmp_1, tmp_2, tmp_3, tmp_4, RGBColorSpaces$SRGB$lambda);
    this.bx_1 = RGBColorSpace_0('Linear sRGB', Illuminant_getInstance().bw_1, LinearTransferFunctions_instance, get_SRGB_R(), get_SRGB_G(), get_SRGB_B());
    this.cx_1 = RGBColorSpace_0('ACES2065-1', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP0_R(), get_ACES_AP0_G(), get_ACES_AP0_B());
    this.dx_1 = RGBColorSpace_0('ACEScc', get_ACES_WHITE_POINT(), ACESccTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.ex_1 = RGBColorSpace_0('ACEScct', get_ACES_WHITE_POINT(), ACEScctTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.fx_1 = RGBColorSpace_0('ACEScg', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.gx_1 = RGBColorSpace_0('Adobe RGB', Illuminant_getInstance().bw_1, new GammaTransferFunctions(2.19921875), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.21, 0.71), xyY_init_$Create$(0.15, 0.06));
    var tmp_5 = this;
    var tmp_6 = Illuminant_getInstance().bw_1;
    var tmp_7 = BT2020TransferFunctions_getInstance();
    var tmp_8 = xyY_init_$Create$(0.708, 0.292);
    var tmp_9 = xyY_init_$Create$(0.17, 0.797);
    var tmp_10 = xyY_init_$Create$(0.131, 0.046);
    tmp_5.hx_1 = new RGBColorSpaceImpl('BT.2020', tmp_6, tmp_7, tmp_8, tmp_9, tmp_10, RGBColorSpaces$BT2020$lambda);
    this.ix_1 = RGBColorSpace_0('BT.709', Illuminant_getInstance().bw_1, BT709TransferFunctions_getInstance(), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.3, 0.6), xyY_init_$Create$(0.15, 0.06));
    this.jx_1 = RGBColorSpace_0('DCI P3', new WhitePoint('DCI P3', xyY_init_$Create$(0.314, 0.351)), new GammaTransferFunctions(2.6), xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.kx_1 = RGBColorSpace_0('Display P3', Illuminant_getInstance().bw_1, SRGBTransferFunctions_instance, xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.lx_1 = RGBColorSpace_0('ROMM RGB', Illuminant_getInstance().zv_1, ROMMTransferFunctions_instance, xyY_init_$Create$(0.7347, 0.2653), xyY_init_$Create$(0.1596, 0.8404), xyY_init_$Create$(0.0366, 1.0E-4));
  }
  var RGBColorSpaces_instance;
  function RGBColorSpaces_getInstance() {
    if (RGBColorSpaces_instance == null)
      new RGBColorSpaces();
    return RGBColorSpaces_instance;
  }
  function SRGB() {
    SRGB_instance = this;
    this.uw_1 = RGBColorSpaces_getInstance().ax_1;
  }
  protoOf(SRGB).fw = function () {
    return this.uw_1.fw();
  };
  protoOf(SRGB).cy = function () {
    return this.uw_1.cy();
  };
  protoOf(SRGB).by = function () {
    return this.uw_1.by();
  };
  protoOf(SRGB).po = function () {
    return this.uw_1.po();
  };
  protoOf(SRGB).mx = function () {
    return this.uw_1.mx();
  };
  protoOf(SRGB).dy = function () {
    return this.uw_1.dy();
  };
  protoOf(SRGB).zx = function (r, g, b, alpha) {
    return this.uw_1.zx(r, g, b, alpha);
  };
  protoOf(SRGB).tw = function (r, g, b, alpha) {
    return this.uw_1.tw(r, g, b, alpha);
  };
  protoOf(SRGB).yx = function (r, g, b, alpha) {
    return this.uw_1.yx(r, g, b, alpha);
  };
  protoOf(SRGB).ay = function (hex) {
    return this.uw_1.ay(hex);
  };
  protoOf(SRGB).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().ax_1, other);
  };
  protoOf(SRGB).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().ax_1);
  };
  protoOf(SRGB).toString = function () {
    return 'sRGB';
  };
  var SRGB_instance;
  function SRGB_getInstance() {
    if (SRGB_instance == null)
      new SRGB();
    return SRGB_instance;
  }
  function RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, convertImpl) {
    this.ty_1 = name;
    this.uy_1 = whitePoint;
    this.vy_1 = transferFunctions;
    this.wy_1 = r;
    this.xy_1 = g;
    this.yy_1 = b;
    this.zy_1 = convertImpl;
    this.az_1 = zeroOneComponentInfo('RGB');
    this.bz_1 = _Matrix___get_rowMajor__impl__vmgxkq(rgbToXyzMatrix(this.uy_1, this.wy_1, this.xy_1, this.yy_1));
    this.cz_1 = _Matrix___get_rowMajor__impl__vmgxkq(inverse(_Matrix___init__impl__q3kp4w(this.bz_1)));
  }
  protoOf(RGBColorSpaceImpl).po = function () {
    return this.ty_1;
  };
  protoOf(RGBColorSpaceImpl).dy = function () {
    return this.uy_1;
  };
  protoOf(RGBColorSpaceImpl).mx = function () {
    return this.vy_1;
  };
  protoOf(RGBColorSpaceImpl).fw = function () {
    return this.az_1;
  };
  protoOf(RGBColorSpaceImpl).by = function () {
    return this.bz_1;
  };
  protoOf(RGBColorSpaceImpl).cy = function () {
    return this.cz_1;
  };
  protoOf(RGBColorSpaceImpl).toString = function () {
    return this.ty_1;
  };
  protoOf(RGBColorSpaceImpl).tw = function (r, g, b, alpha) {
    return new RGB(r, g, b, alpha, this);
  };
  protoOf(RGBColorSpaceImpl).equals = function (other) {
    if (this === other)
      return true;
    if (!(!(other == null) ? isInterface(other, RGBColorSpace) : false))
      return false;
    if (!(this.ty_1 === other.po()))
      return false;
    if (!this.uy_1.equals(other.dy()))
      return false;
    if (!equals(this.vy_1, other.mx()))
      return false;
    if (other instanceof RGBColorSpaceImpl) {
      if (!this.wy_1.equals(other.wy_1))
        return false;
      if (!this.xy_1.equals(other.xy_1))
        return false;
      if (!this.yy_1.equals(other.yy_1))
        return false;
    } else {
      if (!contentEquals(this.bz_1, other.by()))
        return false;
      if (!contentEquals(this.cz_1, other.cy()))
        return false;
    }
    return true;
  };
  protoOf(RGBColorSpaceImpl).hashCode = function () {
    var result = getStringHashCode(this.ty_1);
    result = imul(31, result) + this.uy_1.hashCode() | 0;
    result = imul(31, result) + hashCode(this.vy_1) | 0;
    result = imul(31, result) + this.wy_1.hashCode() | 0;
    result = imul(31, result) + this.xy_1.hashCode() | 0;
    result = imul(31, result) + this.yy_1.hashCode() | 0;
    return result;
  };
  function SRGBTransferFunctions() {
  }
  protoOf(SRGBTransferFunctions).wx = function (x) {
    return x <= 0.0031308 ? x * 12.92 : 1.055 * spow(x, 0.4166666666666667) - 0.055;
  };
  protoOf(SRGBTransferFunctions).vx = function (x) {
    return x <= 0.04045 ? x / 12.92 : spow_0((x + 0.055) / 1.055, 2.4);
  };
  var SRGBTransferFunctions_instance;
  function SRGBTransferFunctions_getInstance() {
    return SRGBTransferFunctions_instance;
  }
  function RGBColorSpace_0(name, whitePoint, transferFunctions, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return new RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, RGBColorSpace$lambda);
  }
  function ACESccTransferFunctions() {
    ACESccTransferFunctions_instance = this;
    this.dz_1 = 3.0517578125E-5;
    this.ez_1 = 1.52587890625E-5;
    this.fz_1 = -0.3013698630136986;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.gz_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACESccTransferFunctions).vx = function (x) {
    var tmp;
    if (x <= -0.3013698630136986) {
      tmp = (spow_0(2.0, x * 17.52 - 9.72) - 1.52587890625E-5) * 2.0;
    } else if (x < this.gz_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACESccTransferFunctions).wx = function (x) {
    var tmp;
    if (x < 3.0517578125E-5) {
      // Inline function 'kotlin.math.log2' call
      var x_0 = 1.52587890625E-5 + coerceAtLeast_0(x, 0.0) / 2.0;
      tmp = (log2(x_0) + 9.72) / 17.52;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACESccTransferFunctions_instance;
  function ACESccTransferFunctions_getInstance() {
    if (ACESccTransferFunctions_instance == null)
      new ACESccTransferFunctions();
    return ACESccTransferFunctions_instance;
  }
  function ACEScctTransferFunctions() {
    ACEScctTransferFunctions_instance = this;
    this.hz_1 = 10.5402377416545;
    this.iz_1 = 0.0729055341958355;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.jz_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACEScctTransferFunctions).vx = function (x) {
    var tmp;
    if (x <= 0.155251141552511) {
      tmp = (x - 0.0729055341958355) / 10.5402377416545;
    } else if (x < this.jz_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACEScctTransferFunctions).wx = function (x) {
    var tmp;
    if (x < 0.0078125) {
      tmp = 10.5402377416545 * x + 0.0729055341958355;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACEScctTransferFunctions_instance;
  function ACEScctTransferFunctions_getInstance() {
    if (ACEScctTransferFunctions_instance == null)
      new ACEScctTransferFunctions();
    return ACEScctTransferFunctions_instance;
  }
  function BT2020TransferFunctions() {
    BT2020TransferFunctions_instance = this;
    this.kz_1 = 1.0993;
    this.lz_1 = 0.0181;
    var tmp = this;
    // Inline function 'kotlin.math.pow' call
    tmp.mz_1 = 1.0993 * Math.pow(0.0181, 0.45) - 0.09929999999999994;
  }
  protoOf(BT2020TransferFunctions).vx = function (x) {
    return numberToDouble(x < this.mz_1 ? x / 4.5 : spow_0((x + 0.09929999999999994) / 1.0993, 2.2222222222222223));
  };
  protoOf(BT2020TransferFunctions).wx = function (x) {
    return x < 0.0181 ? 4.5 * x : 1.0993 * spow(x, 0.45) - 0.09929999999999994;
  };
  var BT2020TransferFunctions_instance;
  function BT2020TransferFunctions_getInstance() {
    if (BT2020TransferFunctions_instance == null)
      new BT2020TransferFunctions();
    return BT2020TransferFunctions_instance;
  }
  function BT709TransferFunctions() {
    BT709TransferFunctions_instance = this;
    this.nz_1 = 1.099 * spow_0(0.018, 0.45) - 0.099;
  }
  protoOf(BT709TransferFunctions).vx = function (x) {
    return numberToDouble(x < this.nz_1 ? x / 4.5 : spow_0((x + 0.099) / 1.099, 2.2222222222222223));
  };
  protoOf(BT709TransferFunctions).wx = function (x) {
    return x < 0.018 ? 4.5 * x : 1.099 * spow(x, 0.45) - 0.099;
  };
  var BT709TransferFunctions_instance;
  function BT709TransferFunctions_getInstance() {
    if (BT709TransferFunctions_instance == null)
      new BT709TransferFunctions();
    return BT709TransferFunctions_instance;
  }
  function ROMMTransferFunctions() {
    this.oz_1 = 0.001953;
  }
  protoOf(ROMMTransferFunctions).vx = function (x) {
    return x < 0.031248 ? x / 16.0 : spow(x, 1.8);
  };
  protoOf(ROMMTransferFunctions).wx = function (x) {
    return x < 0.001953 ? x * 16.0 : spow(x, 0.5555555555555556);
  };
  var ROMMTransferFunctions_instance;
  function ROMMTransferFunctions_getInstance() {
    return ROMMTransferFunctions_instance;
  }
  function rgbToXyzMatrix(whitePoint, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var primaries = _Matrix___init__impl__q3kp4w_0(r.pz_1, g.pz_1, b.pz_1, r.qz_1, g.qz_1, b.qz_1, r.sz(), g.sz(), b.sz());
    var wp = whitePoint.vv_1;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = inverse(primaries);
    var v0 = wp.tz();
    var v1 = wp.rz_1;
    var v2 = wp.uz();
    // Inline function 'com.github.ajalt.colormath.model.rgbToXyzMatrix.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return dotDiagonal(primaries, x, y, z);
  }
  function RGBColorSpace$lambda($this$$receiver, color) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var tmp;
    if (color instanceof RGB) {
      tmp = color.iy($this$$receiver);
    } else {
      tmp = color.kv().oy($this$$receiver);
    }
    return tmp;
  }
  var properties_initialized_RGBColorSpaces_kt_fsnpad;
  function _init_properties_RGBColorSpaces_kt__nc9fsz() {
    if (!properties_initialized_RGBColorSpaces_kt_fsnpad) {
      properties_initialized_RGBColorSpaces_kt_fsnpad = true;
      SRGB_R = xyY_init_$Create$(0.64, 0.33);
      SRGB_G = xyY_init_$Create$(0.3, 0.6);
      SRGB_B = xyY_init_$Create$(0.15, 0.06);
      ACES_WHITE_POINT = new WhitePoint('ACES', xyY_init_$Create$(0.32168, 0.33767));
      ACES_AP0_R = xyY_init_$Create$(0.7347, 0.2653);
      ACES_AP0_G = xyY_init_$Create$(0.0, 1.0);
      ACES_AP0_B = xyY_init_$Create$(1.0E-4, -0.077);
      ACES_AP1_R = xyY_init_$Create$(0.713, 0.293);
      ACES_AP1_G = xyY_init_$Create$(0.165, 0.83);
      ACES_AP1_B = xyY_init_$Create$(0.128, 0.044);
    }
  }
  function Companion_3() {
    Companion_instance_3 = this;
    this.vz_1 = XYZColorSpaces_getInstance().wz_1;
  }
  protoOf(Companion_3).fw = function () {
    return this.vz_1.fw();
  };
  protoOf(Companion_3).dy = function () {
    return this.vz_1.dy();
  };
  protoOf(Companion_3).tw = function (x, y, z, alpha) {
    return this.vz_1.tw(x, y, z, alpha);
  };
  protoOf(Companion_3).hashCode = function () {
    return hashCode(XYZColorSpaces_getInstance().wz_1);
  };
  protoOf(Companion_3).equals = function (other) {
    return equals(XYZColorSpaces_getInstance().wz_1, other);
  };
  var Companion_instance_3;
  function Companion_getInstance_3() {
    if (Companion_instance_3 == null)
      new Companion_3();
    return Companion_instance_3;
  }
  function adaptToM($this, space, m, mi) {
    if (space.dy().equals($this.ny_1.dy()))
      return $this;
    var transform = chromaticAdaptationMatrix(space, $this.ny_1.dy().vv_1, m, mi);
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var v0 = $this.jy_1;
    var v1 = $this.ky_1;
    var v2 = $this.ly_1;
    // Inline function 'com.github.ajalt.colormath.model.XYZ.adaptToM.<anonymous>' call
    var xx = Matrix__get_impl_xogbpk(transform, 0, 0) * v0 + Matrix__get_impl_xogbpk(transform, 1, 0) * v1 + Matrix__get_impl_xogbpk(transform, 2, 0) * v2;
    var yy = Matrix__get_impl_xogbpk(transform, 0, 1) * v0 + Matrix__get_impl_xogbpk(transform, 1, 1) * v1 + Matrix__get_impl_xogbpk(transform, 2, 1) * v2;
    var zz = Matrix__get_impl_xogbpk(transform, 0, 2) * v0 + Matrix__get_impl_xogbpk(transform, 1, 2) * v1 + Matrix__get_impl_xogbpk(transform, 2, 2) * v2;
    return space.tw(xx, yy, zz, $this.my_1);
  }
  function XYZ(x, y, z, alpha, space) {
    Companion_getInstance_3();
    this.jy_1 = x;
    this.ky_1 = y;
    this.ly_1 = z;
    this.my_1 = alpha;
    this.ny_1 = space;
  }
  protoOf(XYZ).iv = function () {
    return this.ny_1;
  };
  protoOf(XYZ).yz = function (space) {
    return adaptToM(this, space, get_CAT02_XYZ_TO_LMS(), get_CAT02_LMS_TO_XYZ());
  };
  protoOf(XYZ).oy = function (space) {
    var tmp0_container = this.yz(XYZColorSpace_0(space.dy()));
    var x = tmp0_container.o6();
    var y = tmp0_container.p6();
    var z = tmp0_container.ye();
    var f = space.mx();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(space.cy());
    // Inline function 'com.github.ajalt.colormath.model.XYZ.toRGB.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_0, 0, 0) * x + Matrix__get_impl_xogbpk(this_0, 1, 0) * y + Matrix__get_impl_xogbpk(this_0, 2, 0) * z;
    var g = Matrix__get_impl_xogbpk(this_0, 0, 1) * x + Matrix__get_impl_xogbpk(this_0, 1, 1) * y + Matrix__get_impl_xogbpk(this_0, 2, 1) * z;
    var b = Matrix__get_impl_xogbpk(this_0, 0, 2) * x + Matrix__get_impl_xogbpk(this_0, 1, 2) * y + Matrix__get_impl_xogbpk(this_0, 2, 2) * z;
    return space.tw(f.wx(r), f.wx(g), f.wx(b), this.my_1);
  };
  protoOf(XYZ).jv = function () {
    return this.oy(RGBColorSpaces_getInstance().ax_1);
  };
  protoOf(XYZ).kv = function () {
    return this;
  };
  protoOf(XYZ).o6 = function () {
    return this.jy_1;
  };
  protoOf(XYZ).p6 = function () {
    return this.ky_1;
  };
  protoOf(XYZ).ye = function () {
    return this.ly_1;
  };
  protoOf(XYZ).toString = function () {
    return 'XYZ(x=' + this.jy_1 + ', y=' + this.ky_1 + ', z=' + this.ly_1 + ', alpha=' + this.my_1 + ', space=' + this.ny_1 + ')';
  };
  protoOf(XYZ).hashCode = function () {
    var result = getNumberHashCode(this.jy_1);
    result = imul(result, 31) + getNumberHashCode(this.ky_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.ly_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.my_1) | 0;
    result = imul(result, 31) + hashCode(this.ny_1) | 0;
    return result;
  };
  protoOf(XYZ).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof XYZ))
      return false;
    var tmp0_other_with_cast = other instanceof XYZ ? other : THROW_CCE();
    if (!equals(this.jy_1, tmp0_other_with_cast.jy_1))
      return false;
    if (!equals(this.ky_1, tmp0_other_with_cast.ky_1))
      return false;
    if (!equals(this.ly_1, tmp0_other_with_cast.ly_1))
      return false;
    if (!equals(this.my_1, tmp0_other_with_cast.my_1))
      return false;
    if (!equals(this.ny_1, tmp0_other_with_cast.ny_1))
      return false;
    return true;
  };
  function XYZColorSpace() {
  }
  function XYZColorSpace_0(whitePoint) {
    return whitePoint.equals(Illuminant_getInstance().bw_1) ? XYZColorSpaces_getInstance().wz_1 : whitePoint.equals(Illuminant_getInstance().zv_1) ? XYZColorSpaces_getInstance().xz_1 : new XYZColorSpaceImpl(whitePoint);
  }
  function XYZColorSpaces() {
    XYZColorSpaces_instance = this;
    this.wz_1 = new XYZColorSpaceImpl(Illuminant_getInstance().bw_1);
    this.xz_1 = new XYZColorSpaceImpl(Illuminant_getInstance().zv_1);
  }
  var XYZColorSpaces_instance;
  function XYZColorSpaces_getInstance() {
    if (XYZColorSpaces_instance == null)
      new XYZColorSpaces();
    return XYZColorSpaces_instance;
  }
  function chromaticAdaptationMatrix(_this__u8e3s4, srcWp, xyzToLms, lmsToXyz) {
    xyzToLms = xyzToLms === VOID ? get_CAT02_XYZ_TO_LMS() : xyzToLms;
    lmsToXyz = lmsToXyz === VOID ? get_CAT02_LMS_TO_XYZ() : lmsToXyz;
    var dstWp = _this__u8e3s4.dy().vv_1;
    var src = dot_0(xyzToLms, srcWp.tz(), srcWp.rz_1, srcWp.uz());
    var dst = dot_0(xyzToLms, dstWp.tz(), dstWp.rz_1, dstWp.uz());
    return dot(dotDiagonal(lmsToXyz, _Vector___get_l__impl__envr1l(dst) / _Vector___get_l__impl__envr1l(src), _Vector___get_m__impl__e5qq0m(dst) / _Vector___get_m__impl__e5qq0m(src), _Vector___get_s__impl__pzuljk(dst) / _Vector___get_s__impl__pzuljk(src)), xyzToLms);
  }
  function XYZColorSpaceImpl(whitePoint) {
    this.zz_1 = whitePoint;
    this.a10_1 = zeroOneComponentInfo('XYZ');
  }
  protoOf(XYZColorSpaceImpl).dy = function () {
    return this.zz_1;
  };
  protoOf(XYZColorSpaceImpl).fw = function () {
    return this.a10_1;
  };
  protoOf(XYZColorSpaceImpl).toString = function () {
    return 'XYZColorSpace(' + this.zz_1 + ')';
  };
  protoOf(XYZColorSpaceImpl).tw = function (x, y, z, alpha) {
    return new XYZ(x, y, z, alpha, this);
  };
  protoOf(XYZColorSpaceImpl).hashCode = function () {
    return this.zz_1.hashCode();
  };
  protoOf(XYZColorSpaceImpl).equals = function (other) {
    var tmp;
    if (!(other == null) ? isInterface(other, XYZColorSpace) : false) {
      tmp = this.zz_1.equals(other.dy());
    } else {
      tmp = false;
    }
    return tmp;
  };
  function xyY_init_$Init$(x, y, Y, $this) {
    Y = Y === VOID ? 1.0 : Y;
    xyY.call($this, numberToDouble(x), numberToDouble(y), numberToDouble(Y));
    return $this;
  }
  function xyY_init_$Create$(x, y, Y) {
    return xyY_init_$Init$(x, y, Y, objectCreate(protoOf(xyY)));
  }
  function xyY(x, y, Y) {
    Y = Y === VOID ? 1.0 : Y;
    this.pz_1 = x;
    this.qz_1 = y;
    this.rz_1 = Y;
  }
  protoOf(xyY).sz = function () {
    return 1 - this.pz_1 - this.qz_1;
  };
  protoOf(xyY).tz = function () {
    return this.pz_1 * this.rz_1 / this.qz_1;
  };
  protoOf(xyY).uz = function () {
    return (1 - this.pz_1 - this.qz_1) * this.rz_1 / this.qz_1;
  };
  protoOf(xyY).toString = function () {
    return 'xyY(x=' + this.pz_1 + ', y=' + this.qz_1 + ', Y=' + this.rz_1 + ')';
  };
  protoOf(xyY).hashCode = function () {
    var result = getNumberHashCode(this.pz_1);
    result = imul(result, 31) + getNumberHashCode(this.qz_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.rz_1) | 0;
    return result;
  };
  protoOf(xyY).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof xyY))
      return false;
    var tmp0_other_with_cast = other instanceof xyY ? other : THROW_CCE();
    if (!equals(this.pz_1, tmp0_other_with_cast.pz_1))
      return false;
    if (!equals(this.qz_1, tmp0_other_with_cast.qz_1))
      return false;
    if (!equals(this.rz_1, tmp0_other_with_cast.rz_1))
      return false;
    return true;
  };
  //region block: post-declaration
  protoOf(Ansi16).kv = toXYZ;
  protoOf(Ansi256).kv = toXYZ;
  protoOf(HSV).kv = toXYZ;
  protoOf(Companion_2).iw = from255$default;
  protoOf(Companion_2).hw = invoke$default;
  protoOf(Companion_2).mw = invoke$default_0;
  protoOf(SRGB).iw = from255$default;
  protoOf(SRGB).hw = invoke$default;
  protoOf(SRGB).mw = invoke$default_0;
  protoOf(RGBColorSpaceImpl).hw = invoke$default;
  protoOf(RGBColorSpaceImpl).yx = invoke;
  protoOf(RGBColorSpaceImpl).mw = invoke$default_0;
  protoOf(RGBColorSpaceImpl).ay = invoke_0;
  protoOf(RGBColorSpaceImpl).zx = from255;
  protoOf(RGBColorSpaceImpl).iw = from255$default;
  //endregion
  //region block: init
  PqNonlinearity_instance = new PqNonlinearity();
  LinearTransferFunctions_instance = new LinearTransferFunctions();
  SRGBTransferFunctions_instance = new SRGBTransferFunctions();
  ROMMTransferFunctions_instance = new ROMMTransferFunctions();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Ansi16;
  _.$_$.b = Ansi256;
  _.$_$.c = Companion_getInstance_2;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=colormath-root-colormath.js.map
