(function (_, kotlin_kotlin, kotlin_clikt_clikt, kotlin_com_zegreatrob_tools_tagger_core, kotlin_com_zegreatrob_tools_git_adapter, kotlin_com_zegreatrob_tools_cli_tools) {
  'use strict';
  //region block: imports
  var Unit_instance = kotlin_kotlin.$_$.v1;
  var CliktCommand = kotlin_clikt_clikt.$_$.a;
  var argument = kotlin_clikt_clikt.$_$.d;
  var option = kotlin_clikt_clikt.$_$.g;
  var boolean = kotlin_clikt_clikt.$_$.i;
  var default_0 = kotlin_clikt_clikt.$_$.e;
  var Defaults_getInstance = kotlin_com_zegreatrob_tools_tagger_core.$_$.h;
  var Companion_instance = kotlin_com_zegreatrob_tools_tagger_core.$_$.g;
  var GitAdapter = kotlin_com_zegreatrob_tools_git_adapter.$_$.a;
  var TaggerCore = kotlin_com_zegreatrob_tools_tagger_core.$_$.b;
  var RegexOption_IGNORE_CASE_getInstance = kotlin_kotlin.$_$.d;
  var Regex_init_$Create$ = kotlin_kotlin.$_$.n;
  var VersionRegex = kotlin_com_zegreatrob_tools_tagger_core.$_$.c;
  var calculateNextVersion = kotlin_com_zegreatrob_tools_tagger_core.$_$.d;
  var protoOf = kotlin_kotlin.$_$.d6;
  var classMeta = kotlin_kotlin.$_$.i5;
  var setMetadataFor = kotlin_kotlin.$_$.e6;
  var VOID = kotlin_kotlin.$_$.c;
  var KProperty1 = kotlin_kotlin.$_$.u6;
  var getPropertyCallableRef = kotlin_kotlin.$_$.o5;
  var platformArgCorrection = kotlin_com_zegreatrob_tools_cli_tools.$_$.a;
  var subcommands = kotlin_clikt_clikt.$_$.c;
  var required = kotlin_clikt_clikt.$_$.h;
  var tag = kotlin_com_zegreatrob_tools_tagger_core.$_$.e;
  var CliktError = kotlin_clikt_clikt.$_$.b;
  var Error_0 = kotlin_com_zegreatrob_tools_tagger_core.$_$.a;
  var Success_getInstance = kotlin_com_zegreatrob_tools_tagger_core.$_$.f;
  var equals = kotlin_kotlin.$_$.k5;
  var flag = kotlin_clikt_clikt.$_$.f;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CalculateVersion, 'CalculateVersion', classMeta, CliktCommand, VOID, CalculateVersion);
  setMetadataFor(Tag, 'Tag', classMeta, CliktCommand, VOID, Tag);
  setMetadataFor(Tagger, 'Tagger', classMeta, CliktCommand, VOID, Tagger);
  //endregion
  function _get_dir__e67350($this) {
    return $this.h2j_1.t2f($this, dir$factory_0());
  }
  function _get_implicitPatch__bjk4pa($this) {
    return $this.i2j_1.t2f($this, implicitPatch$factory_0());
  }
  function _get_releaseBranch__pqrgbs($this) {
    return $this.j2j_1.t2f($this, releaseBranch$factory_0());
  }
  function _get_majorRegex__5j6ypp($this) {
    return $this.k2j_1.t2f($this, majorRegex$factory_0());
  }
  function _get_minorRegex__20z96h($this) {
    return $this.l2j_1.t2f($this, minorRegex$factory_0());
  }
  function _get_patchRegex__mtlu2c($this) {
    return $this.m2j_1.t2f($this, patchRegex$factory_0());
  }
  function _get_noneRegex__1tdbgi($this) {
    return $this.n2j_1.t2f($this, noneRegex$factory_0());
  }
  function _get_versionRegex__7su5ss($this) {
    return $this.o2j_1.t2f($this, versionRegex$factory_0());
  }
  function run$echo(receiver, p0) {
    receiver.x26(p0);
  }
  function CalculateVersion$versionRegex$delegate$lambda($tmp2_check_this, $message) {
    return function ($this$copy, it) {
      var tmp;
      if (!(it == null)) {
        var tmp_0;
        if (!$tmp2_check_this.hv(it)) {
          // Inline function 'com.github.ajalt.clikt.parameters.options.check.<anonymous>.<anonymous>' call
          // Inline function 'com.github.ajalt.clikt.parameters.options.check.<anonymous>' call
          var tmp$ret$2 = $message;
          $this$copy.c2f(tmp$ret$2);
        }
        tmp = tmp_0;
      }
      return Unit_instance;
    };
  }
  function CalculateVersion() {
    CliktCommand.call(this);
    this.h2j_1 = argument(this, 'git-repo').v2f(this, dir$factory());
    this.i2j_1 = default_0(boolean(option(this, [])), true).g2g(this, implicitPatch$factory());
    this.j2j_1 = option(this, []).g2g(this, releaseBranch$factory());
    this.k2j_1 = default_0(option(this, []), Defaults_getInstance().fv_1.b8_1).g2g(this, majorRegex$factory());
    this.l2j_1 = default_0(option(this, []), Defaults_getInstance().ev_1.b8_1).g2g(this, minorRegex$factory());
    this.m2j_1 = default_0(option(this, []), Defaults_getInstance().dv_1.b8_1).g2g(this, patchRegex$factory());
    this.n2j_1 = default_0(option(this, []), Defaults_getInstance().cv_1.b8_1).g2g(this, noneRegex$factory());
    var tmp = this;
    // Inline function 'com.github.ajalt.clikt.parameters.options.check' call
    var this_0 = option(this, []);
    var message = "version regex must include groups named 'major', 'minor', 'patch', and 'none'.";
    // Inline function 'com.github.ajalt.clikt.parameters.options.check' call
    // Inline function 'com.github.ajalt.clikt.parameters.options.validate' call
    var tmp_0 = this_0.x2f();
    var tmp_1 = this_0.y2f();
    var tmp_2 = this_0.z2f();
    tmp.o2j_1 = this_0.a2g(tmp_0, tmp_1, tmp_2, CalculateVersion$versionRegex$delegate$lambda(Companion_instance, message)).g2g(this, versionRegex$factory());
  }
  protoOf(CalculateVersion).e27 = function () {
    // Inline function 'kotlin.let' call
    var tmp = new TaggerCore(new GitAdapter(_get_dir__e67350(this)));
    var tmp_0 = _get_implicitPatch__bjk4pa(this);
    var tmp_1 = Regex_init_$Create$(_get_noneRegex__1tdbgi(this), RegexOption_IGNORE_CASE_getInstance());
    var tmp_2 = Regex_init_$Create$(_get_patchRegex__mtlu2c(this), RegexOption_IGNORE_CASE_getInstance());
    var tmp_3 = Regex_init_$Create$(_get_minorRegex__20z96h(this), RegexOption_IGNORE_CASE_getInstance());
    var tmp_4 = Regex_init_$Create$(_get_majorRegex__5j6ypp(this), RegexOption_IGNORE_CASE_getInstance());
    var tmp0_safe_receiver = _get_versionRegex__7su5ss(this);
    var tmp_5;
    if (tmp0_safe_receiver == null) {
      tmp_5 = null;
    } else {
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.zegreatrob.tools.tagger.cli.CalculateVersion.run.<anonymous>' call
      tmp_5 = Regex_init_$Create$(tmp0_safe_receiver, RegexOption_IGNORE_CASE_getInstance());
    }
    var tmp_6 = new VersionRegex(tmp_1, tmp_2, tmp_3, tmp_4, tmp_5);
    var tmp1_elvis_lhs = _get_releaseBranch__pqrgbs(this);
    var this_0 = calculateNextVersion(tmp, tmp_0, tmp_6, tmp1_elvis_lhs == null ? '' : tmp1_elvis_lhs);
    // Inline function 'kotlin.contracts.contract' call
    run$echo(this, this_0);
  };
  function dir$factory() {
    return getPropertyCallableRef('dir', 1, KProperty1, function (receiver) {
      return _get_dir__e67350(receiver);
    }, null);
  }
  function implicitPatch$factory() {
    return getPropertyCallableRef('implicitPatch', 1, KProperty1, function (receiver) {
      return _get_implicitPatch__bjk4pa(receiver);
    }, null);
  }
  function releaseBranch$factory() {
    return getPropertyCallableRef('releaseBranch', 1, KProperty1, function (receiver) {
      return _get_releaseBranch__pqrgbs(receiver);
    }, null);
  }
  function majorRegex$factory() {
    return getPropertyCallableRef('majorRegex', 1, KProperty1, function (receiver) {
      return _get_majorRegex__5j6ypp(receiver);
    }, null);
  }
  function minorRegex$factory() {
    return getPropertyCallableRef('minorRegex', 1, KProperty1, function (receiver) {
      return _get_minorRegex__20z96h(receiver);
    }, null);
  }
  function patchRegex$factory() {
    return getPropertyCallableRef('patchRegex', 1, KProperty1, function (receiver) {
      return _get_patchRegex__mtlu2c(receiver);
    }, null);
  }
  function noneRegex$factory() {
    return getPropertyCallableRef('noneRegex', 1, KProperty1, function (receiver) {
      return _get_noneRegex__1tdbgi(receiver);
    }, null);
  }
  function versionRegex$factory() {
    return getPropertyCallableRef('versionRegex', 1, KProperty1, function (receiver) {
      return _get_versionRegex__7su5ss(receiver);
    }, null);
  }
  function dir$factory_0() {
    return getPropertyCallableRef('dir', 1, KProperty1, function (receiver) {
      return _get_dir__e67350(receiver);
    }, null);
  }
  function implicitPatch$factory_0() {
    return getPropertyCallableRef('implicitPatch', 1, KProperty1, function (receiver) {
      return _get_implicitPatch__bjk4pa(receiver);
    }, null);
  }
  function releaseBranch$factory_0() {
    return getPropertyCallableRef('releaseBranch', 1, KProperty1, function (receiver) {
      return _get_releaseBranch__pqrgbs(receiver);
    }, null);
  }
  function majorRegex$factory_0() {
    return getPropertyCallableRef('majorRegex', 1, KProperty1, function (receiver) {
      return _get_majorRegex__5j6ypp(receiver);
    }, null);
  }
  function minorRegex$factory_0() {
    return getPropertyCallableRef('minorRegex', 1, KProperty1, function (receiver) {
      return _get_minorRegex__20z96h(receiver);
    }, null);
  }
  function patchRegex$factory_0() {
    return getPropertyCallableRef('patchRegex', 1, KProperty1, function (receiver) {
      return _get_patchRegex__mtlu2c(receiver);
    }, null);
  }
  function noneRegex$factory_0() {
    return getPropertyCallableRef('noneRegex', 1, KProperty1, function (receiver) {
      return _get_noneRegex__1tdbgi(receiver);
    }, null);
  }
  function versionRegex$factory_0() {
    return getPropertyCallableRef('versionRegex', 1, KProperty1, function (receiver) {
      return _get_versionRegex__7su5ss(receiver);
    }, null);
  }
  function main(args) {
    return cli().d27(platformArgCorrection(args));
  }
  function cli() {
    return subcommands(subcommands(new Tagger(), [new CalculateVersion()]), [new Tag()]);
  }
  function _get_dir__e67350_0($this) {
    return $this.g2k_1.t2f($this, dir$factory_2());
  }
  function _get_releaseBranch__pqrgbs_0($this) {
    return $this.h2k_1.t2f($this, releaseBranch$factory_2());
  }
  function _get_version__2bx7w9($this) {
    return $this.i2k_1.t2f($this, version$factory_0());
  }
  function _get_warningsAsErrors__7mpwfd($this) {
    return $this.j2k_1.t2f($this, warningsAsErrors$factory_0());
  }
  function Tag() {
    CliktCommand.call(this);
    this.g2k_1 = argument(this, 'git-repo').v2f(this, dir$factory_1());
    this.h2k_1 = required(option(this, [])).g2g(this, releaseBranch$factory_1());
    this.i2k_1 = required(option(this, [])).g2g(this, version$factory());
    this.j2k_1 = default_0(boolean(option(this, [])), false).g2g(this, warningsAsErrors$factory());
  }
  protoOf(Tag).e27 = function () {
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    var it = tag(new TaggerCore(new GitAdapter(_get_dir__e67350_0(this))), _get_version__2bx7w9(this), _get_releaseBranch__pqrgbs_0(this));
    var tmp;
    if (equals(it, Success_getInstance())) {
      this.x26('Success!');
      tmp = Unit_instance;
    } else {
      if (it instanceof Error_0) {
        var tmp_0;
        if (_get_warningsAsErrors__7mpwfd(this)) {
          throw new CliktError(it.bv_1);
        } else {
          this.x26(it.bv_1, VOID, true);
          tmp_0 = Unit_instance;
        }
        tmp = tmp_0;
      }
    }
  };
  function dir$factory_1() {
    return getPropertyCallableRef('dir', 1, KProperty1, function (receiver) {
      return _get_dir__e67350_0(receiver);
    }, null);
  }
  function releaseBranch$factory_1() {
    return getPropertyCallableRef('releaseBranch', 1, KProperty1, function (receiver) {
      return _get_releaseBranch__pqrgbs_0(receiver);
    }, null);
  }
  function version$factory() {
    return getPropertyCallableRef('version', 1, KProperty1, function (receiver) {
      return _get_version__2bx7w9(receiver);
    }, null);
  }
  function warningsAsErrors$factory() {
    return getPropertyCallableRef('warningsAsErrors', 1, KProperty1, function (receiver) {
      return _get_warningsAsErrors__7mpwfd(receiver);
    }, null);
  }
  function dir$factory_2() {
    return getPropertyCallableRef('dir', 1, KProperty1, function (receiver) {
      return _get_dir__e67350_0(receiver);
    }, null);
  }
  function releaseBranch$factory_2() {
    return getPropertyCallableRef('releaseBranch', 1, KProperty1, function (receiver) {
      return _get_releaseBranch__pqrgbs_0(receiver);
    }, null);
  }
  function version$factory_0() {
    return getPropertyCallableRef('version', 1, KProperty1, function (receiver) {
      return _get_version__2bx7w9(receiver);
    }, null);
  }
  function warningsAsErrors$factory_0() {
    return getPropertyCallableRef('warningsAsErrors', 1, KProperty1, function (receiver) {
      return _get_warningsAsErrors__7mpwfd(receiver);
    }, null);
  }
  function _get_quiet__c6dzoj($this) {
    return $this.b2l_1.t2f($this, quiet$factory_0());
  }
  function Tagger() {
    CliktCommand.call(this);
    this.b2l_1 = flag(option(this, ['--quiet', '-q']), [], false).g2g(this, quiet$factory());
  }
  protoOf(Tagger).e27 = function () {
    if (!_get_quiet__c6dzoj(this)) {
      this.x26('Welcome to Tagger CLI.');
    }
  };
  function quiet$factory() {
    return getPropertyCallableRef('quiet', 1, KProperty1, function (receiver) {
      return _get_quiet__c6dzoj(receiver);
    }, null);
  }
  function quiet$factory_0() {
    return getPropertyCallableRef('quiet', 1, KProperty1, function (receiver) {
      return _get_quiet__c6dzoj(receiver);
    }, null);
  }
  main([]);
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./clikt-clikt.js'), require('./tools-tagger-core.js'), require('./tools-git-adapter.js'), require('./tools-cli-tools.js')));

//# sourceMappingURL=tools-tagger-cli.js.map
